﻿using System;
using System.Data;
using System.Data.Common;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;

public partial class Panier : System.Web.UI.Page
{
 protected void Page_Load(object sender, EventArgs e)
 {
  if (IsPostBack==false)
  CalculerAfficherPanier();
 }

 private void CalculerAfficherPanier()
 {
  List<string> panier = Session["PANIER"] as List<string>;
  if (panier == null) return;

  DataTable dt = new DataTable();
  DataColumn dc = new DataColumn("ISBN", typeof(string)); dt.Columns.Add(dc);
  dc = new DataColumn("Titre", typeof(string)); dt.Columns.Add(dc);
  dc = new DataColumn("Auteur", typeof(string)); dt.Columns.Add(dc);
  dc = new DataColumn("Prix", typeof(decimal)); dt.Columns.Add(dc);

  DbProviderFactory dbpf = DbProviderFactories.GetFactory("System.Data.OleDb");
  DbConnection oConn = dbpf.CreateConnection();
  oConn.ConnectionString = ConfigurationManager.ConnectionStrings["LibrairieConnectionString"].ConnectionString ;
  oConn.Open();

  for (int li = 0; li < panier.Count; li++)
  {
   string isbn = panier[li];
   DataRow dr = dt.NewRow();
   dr["ISBN"] = isbn;
 
   DbCommand oCmd = oConn.CreateCommand();
   oCmd.CommandText = "SELECT * FROM Ouvrages WHERE ISBN='" + isbn + "'";
   DbDataReader oRdr = oCmd.ExecuteReader();
   if (oRdr != null && oRdr.Read())
   {
    dr["Titre"] = oRdr["Titre"];
    dr["Auteur"] = oRdr["Auteur"];
    dr["Prix"] = oRdr["Prix"];
    dt.Rows.Add(dr);
   }
  }
  oConn.Close();
  gv.DataSource = dt;
  gv.DataBind();

  // afficher le montant du panier
  decimal somme = 0M;
  for (int li = 0; li < dt.Rows.Count; li++)
   somme += (decimal)dt.Rows[li]["Prix"];
  zaMontantPanier.Text = "Montant du panier : " + somme + " euros";

  bPasserCommande.Enabled = somme != 0M ? true : false;
 }

 protected void gv_RowCommand(object sender, GridViewCommandEventArgs e)
 {
  int n = -1;
  Int32.TryParse(e.CommandArgument.ToString(), out n);
  string isbn = gv.DataKeys[n].Value.ToString();
  List<string> panier = (List<string>)Session["PANIER"];
  if (panier != null) panier.Remove(isbn);
  CalculerAfficherPanier();
 }
 protected void gv_RowDeleting(object sender, GridViewDeleteEventArgs e)
 {

 }
 protected void bPasserCommande_Click(object sender, EventArgs e)
 {
  List<string> panier = (List<string>)Session["PANIER"];
  if (panier != null) Response.Redirect("Commande.aspx"); 
 }
}
